/**
 * 
 */
package com.company.unit;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.definition.KnowledgePackage;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;

/**
 * 
 *
 */
public class OldStyleRuleFlowTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		KnowledgeBase kbase = getBase();
		final StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();

		// Run the session
		String someString = "Some String";
		Map<String, Object> variables = new HashMap<String, Object>();
		variables.put("someString", someString);
		
		// This works as well
		ksession.startProcess("SampleFlow", variables);
		ksession.fireAllRules();

		ksession.dispose();
		System.out.println("Done");
	}

	private static KnowledgeBase getBase() {
		final KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();

		kbuilder.add(ResourceFactory.newClassPathResource("SampleFlow.rf"), ResourceType.DRF);
		if (kbuilder.hasErrors()) {
			System.out.println(kbuilder.getErrors().toString());
			throw new RuntimeException("Unable to compile");
		}
		final Collection<KnowledgePackage> pkgs = kbuilder.getKnowledgePackages();
		final KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
		kbase.addKnowledgePackages(pkgs);
		return kbase;
	}
}
